@if ($fileViewer(); as fileViewer) {
  <nz-layout class="full-height">
    <nz-header class="layout-header">
      <div class="header-container">
        <div class="flex">
          <div>
            <span
              nz-icon
              nzType="sqtm-core-campaign:exec_report"
              nzTheme="twotone"
              class="file-icon"
            ></span>
          </div>
          <div class="flex-column" style="color: whitesmoke">
            <p>
              {{
                !data.filePath
                  ? fileViewer.attachment.name
                  : getFileNameFromPath()
              }}
            </p>
          </div>
        </div>

        <div class="flex">
          <div>
            <a
              [href]="getAttachmentDownloadURL(fileViewer.attachment)"
              target="_blank"
            >
              <i
                class="icon-preview"
                nz-icon
                nzType="sqtm-core-generic:download"
                nzTheme="outline"
              ></i>
            </a>
          </div>
          <div>
            <i
              class="icon-preview"
              nz-icon
              nzType="sqtm-core-generic:close"
              nzTheme="outline"
              sqtmCoreDialogClose
            ></i>
          </div>
        </div>
      </div>
    </nz-header>

    <div class="parent-container">
      @if (fileViewer.isArchive) {
        <div class="flex full-height directory-tree">
          <ng-container>
            <sqtm-core-archive-tree
              class="full-width"
              [archive]="fileViewer.attachment"
              (displayFile)="displayArchiveFile($event)"
              (handleError)="handlePreviewError($event)"
            ></sqtm-core-archive-tree>
          </ng-container>
        </div>
      }

      <div class="content-container full-width full-height">
        <div class="file-preview full-height">
          <nz-content class="full-height">
            @switch (fileViewer.viewerType) {
              @case (FileViewerType.UNKNOWN) {
                <ng-container *ngTemplateOutlet="unknown"></ng-container>
              }

              @case (FileViewerType.IFRAME) {
                <ng-container *ngTemplateOutlet="iframe"></ng-container>
              }

              @case (FileViewerType.IMG) {
                <ng-container *ngTemplateOutlet="image"></ng-container>
              }

              @case (FileViewerType.PRE) {
                <ng-container *ngTemplateOutlet="pre"></ng-container>
              }

              @case (FileViewerType.ERROR) {
                <ng-container *ngTemplateOutlet="error"></ng-container>
              }

              @case (FileViewerType.FORBIDDEN) {
                <ng-container *ngTemplateOutlet="forbidden"></ng-container>
              }
            }
          </nz-content>
        </div>

        <div class="icon-container">
          <span
            class="slide-button m-l-20"
            style="left: 0"
            nz-icon
            nzType="left"
            nzTheme="outline"
            [class.disabled]="data.filePath || attachments.length == 1"
            (click)="updatePreview(fileViewer.index - 1)"
          ></span>
          <span
            class="slide-button m-r-20"
            style="right: 0"
            nz-icon
            nzType="right"
            nzTheme="outline"
            [class.disabled]="data.filePath || attachments.length == 1"
            (click)="updatePreview(fileViewer.index + 1)"
          ></span>
        </div>
      </div>
    </div>
  </nz-layout>

  <ng-template #unknown>
    <div class="invalid-file full-width flex-column full-height">
      <span nz-icon nzType="sqtm-core-generic:warning" nzTheme="outline"></span>
      <div
        class="error-message"
        [innerHTML]="'sqtm-core.file-viewer.invalid-file' | translate"
      ></div>
    </div>
  </ng-template>

  <ng-template #error>
    <div class="invalid-file full-width flex-column full-height">
      <span nz-icon nzType="sqtm-core-generic:warning" nzTheme="outline"></span>
      <div
        class="error-message"
        [innerHTML]="'sqtm-core.file-viewer.error' | translate"
      ></div>
    </div>
  </ng-template>

  <ng-template #forbidden>
    <div class="invalid-file full-width flex-column full-height">
      <span nz-icon nzType="sqtm-core-generic:warning" nzTheme="outline"></span>
      <div
        class="error-message"
        [innerHTML]="'sqtm-core.file-viewer.forbidden' | translate"
      ></div>
    </div>
  </ng-template>

  <ng-template #image>
    <div class="image-container full-width full-height">
      <ng-container>
        @if ($isLoading()) {
          <sqtm-core-full-page-loading-icon
            class="full-width"
          ></sqtm-core-full-page-loading-icon>
        }

        <img
          #imageElement
          class="m-auto"
          [alt]="
            !data.filePath ? fileViewer.attachment.name : getFileNameFromPath()
          "
          [hidden]="$isLoading()"
          [src]="$url()"
          (error)="handlePreviewError($event)"
        />
      </ng-container>
    </div>
  </ng-template>

  <ng-template #iframe>
    <div class="full-height">
      @if ($isLoading()) {
        <sqtm-core-full-page-loading-icon
          class="full-width"
        ></sqtm-core-full-page-loading-icon>
      }

      <iframe
        #iframeElement
        sqtmCoreIframeSource
        [src]="$url()"
        [hidden]="$isLoading()"
        class="full-height full-width"
        style="background-color: white"
        title="File preview"
      ></iframe>
    </div>
  </ng-template>

  <ng-template #pre>
    <div class="full-height">
      @if ($isLoading()) {
        <sqtm-core-full-page-loading-icon
          class="full-width"
        ></sqtm-core-full-page-loading-icon>
      }

      <div class="full-width full-height">
        <pre class="full-height">
          <code [textContent]="fileViewer.content"></code>
        </pre>
      </div>
    </div>
  </ng-template>
}
